//==============================================================================
//
// KbdLedDlg.cpp
//
// ZapIo ̹ ̿ I/O Ʈ  α׷ ..
//   User Mode μ I/O Ʈ   Ͽ Ű
// ͷѷ ϴ° ش.
//
//  -  : 2003 1 4
//  -  : 
//  - ̸ : AlphaMCU@hanmail.net
//  - ּ : http://www.zap.pe.kr
//
//  - Copyright (C) 2002~2003 Kyung-Ryul Sun.
//
//==============================================================================

#include "stdafx.h"
#include "KbdLed.h"
#include "KbdLedDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <conio.h> // for _outp, _inp

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKbdLedDlg dialog

CKbdLedDlg::CKbdLedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKbdLedDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKbdLedDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKbdLedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKbdLedDlg)
	DDX_Control(pDX, IDC_SHOW_CHECK, m_ShowButton);
	DDX_Control(pDX, IDC_SYM_EDIT, m_SymEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKbdLedDlg, CDialog)
	//{{AFX_MSG_MAP(CKbdLedDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SHOW_CHECK, OnShowButton)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_ABOUT_BUTTON, OnAboutButton)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKbdLedDlg message handlers

BOOL CKbdLedDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	TCHAR *pSymLinkName = (TCHAR*)zio_LoadZapIo();
	if(pSymLinkName == NULL) {
		m_ShowButton.EnableWindow(FALSE);
	} else {
		m_SymEdit.SetWindowText(pSymLinkName);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CKbdLedDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKbdLedDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKbdLedDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#define TIMER_ID	1
void CKbdLedDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(TIMER_ID);
	zio_UnloadZapIo(); 
	
	CDialog::OnClose();
}

void CKbdLedDlg::OnAboutButton() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CKbdLedDlg::OnShowButton() 
{
#define CHECKED		1
#define UNCHECKED	0

	if(m_ShowButton.GetCheck() == CHECKED) {
		m_ShowButton.SetWindowText(TEXT(""));
		SetTimer(TIMER_ID, 300 /* interval */, NULL);
	} else {
		m_ShowButton.SetWindowText(TEXT("̱"));
		KillTimer(TIMER_ID);
	}
}

void CKbdLedDlg::OnTimer(UINT nIDEvent) 
{
	BYTE arData[12] = {0x00, 0x02, 0x04, 0x01, 0x04, 0x02, 0x00, 0x06, 0x00, 0x05, 0x00, 0x07};
	static int pos=0;

	if(nIDEvent != 1) goto $exit;

	if(!IsBufferEmtpy()) goto $exit;
	_outp(0x60, 0xed);
	if(!IsBufferEmtpy()) goto $exit;
	_outp(0x60, arData[pos]);
	if(++pos >= (sizeof(arData)/sizeof(BYTE))) pos=0;
	
$exit:	
	CDialog::OnTimer(nIDEvent);
}


void CKbdLedDlg::PortDelay(void)
{
	_outp(0x80, 1);
}

BOOL CKbdLedDlg::IsBufferEmtpy(void)
{
	for(WORD count=0xffff; count>0; count--) {
		PortDelay();
		BYTE read=_inp(0x64);
		if(!(read&0x01)) { if(read&0x02) continue; }
		PortDelay();
		_inp(0x60);
		return TRUE;
	}

	return FALSE;
}
